/*

 Kit d'arrosage automatique de DFRobot:http://www.dfrobot.com/index.php?route=product/product&filter_name=auto%20watering&product_id=641#.UUAW7xwqAZ4

  Fonctions:
  1.Mise en route d'une pompe pour arroser les plantes en fonction de l'humidite et de la temperature
  2.Utilisation du capteur DHT11 pour mesurer l'humidite ambiante et la temperature
  3.Utiliser le capteur d'humiditÃ© pour tester l'humidite du sol
  
  AutoWatering.cpp - Library for Auto Flower Watering Kit Bibliotheque pour arrosage automatique des plantes
  Modifie le 12 mars 2013, traduit en francais le 01 septembre 2015
  v0.1
*/

#include <avr/eeprom.h>
#include "AutoWatering.h"
#include <DHT.h>

#define MoiPIN 2   //Le capteur d'humidite est connecte A2
#define DHTPIN 9  //Le capteur DHT11 est connecte a D9

//Desactivation du commentaire quelque soit le type utilise!
  #define DHTTYPE DHT11   // DHT 11 
//#define DHTTYPE DHT22   // DHT 22  (AM2302)
//#define DHTTYPE DHT21   // DHT 21 (AM2301)

DHT dht(DHTPIN, DHTTYPE);

int dat[]={0x55,0xaa,0x00,0x00,0x00};

int AutoWatering::getTemperature() //Mesurer la temperature via le capteur DHT11
{    
  int temperature;
  temperature = dht.readTemperature();  
  return temperature; 
}

int AutoWatering::getHumidity()  //Mesurer l'humidite via le capteur DHT11
{
    int humidity;
  humidity = dht.readHumidity();  
  return humidity;
}

int AutoWatering::MoistureSensor() //Mesurer l'humidite du sol via le capteur d'humidite 
{
   int moisture_dat;
   moisture_dat=analogRead(MoiPIN);   //Le capteur d'humidite est connecte a A2
   if(moisture_dat<500)moisture_dat=moisture_dat/5;
   else moisture_dat=100;
   return moisture_dat;
}

int AutoWatering::CarbonRod()   //Mesurer l'humidite du sol via le capteur Carbone
{
   int humidity_dat;
   digitalWrite(2,LOW);
   digitalWrite(3,HIGH);
   delay(500);
   digitalWrite(2,HIGH);
   digitalWrite(3,LOW);
   humidity_dat=analogRead(0);     //Les cosses en carbone sont connectees a A0
   if(humidity_dat<500)humidity_dat=humidity_dat/5;
   else humidity_dat=100;
   Serial.print("L'humidite du sol est de : " );
   Serial.print(humidity_dat);
   Serial.println("%");
   return humidity_dat;
}

int AutoWatering::ADJ_humMax() //Humidity ADJ est utilisee pour ajuster la valeur maximum de l'humidite du sol
{
   int dat;
   dat=analogRead(1);             //Humidite maximum connectee a A1
   dat=map(dat, 0, 1023, 0, 100);
   Serial.print("L'humidite maximum definie est : " );
   Serial.print(dat);
   Serial.println("%");
   return dat;
}
 

void AutoWatering::pumpOff()  //Eteindre la pompe
{
  Serial.println("La pompe est maintenant eteinte!");
  digitalWrite(5,LOW);
  digitalWrite(6,LOW); 
  digitalWrite(7,LOW);
  digitalWrite(4,LOW);  
}

void AutoWatering::pumpTestOn() //Demarrage de la pompe pour verifier son bon fonctionnement
{
  Serial.print("La pompe peut fonctionner correctement!");
  digitalWrite(5,HIGH);
  digitalWrite(6,HIGH);  
}

void AutoWatering::Initialization() //Initialisation du kit d'arrosage
{
    pinMode(2,OUTPUT);
    pinMode(3,OUTPUT);
    pinMode(4,OUTPUT);
    pinMode(5,OUTPUT);
    pinMode(6,OUTPUT);
    pinMode(7,OUTPUT);
    digitalWrite(6,LOW);
    digitalWrite(4,LOW);
    digitalWrite(5,LOW);
    digitalWrite(7,LOW);
    dht.begin();
}


