/*
  
  Kit d'arrosage automatique de DFRobot:http://www.dfrobot.com/index.php?route=product/product&filter_name=auto%20watering&product_id=641#.UUAW7xwqAZ4

  Fonctions:
  1.Mise en route d'une pompe pour arroser les plantes en fonction de l'humidite et de la temperature
  2.Utilisation du capteur DHT11 pour mesurer l'humidite ambiante et la temperature
  3.Utiliser le capteur d'humidite pour tester l'humidite du sol
  
  AutoWatering.cpp - Library for Auto Flower Watering Kit Bibliotheque pour arrosage automatique des plantes
  Modifie le 12 mars 2013, traduit en francais le 01 septembre 2015
  v0.1
*/

#ifndef AutoWatering_h
#define AutoWatering_h
#include <avr/eeprom.h>
//#include <arduino.h>

class AutoWatering
{
  public:
  uint8_t value,SUM;
  int getTemperature();          //Mesurer la temperature via le capteur DHT11
  int getHumidity();            //Mesurer l'humidite via le capteur DHT11
  int MoistureSensor();        //Mesurer l'humidite du sol via le capteur d'humidite
  int CarbonRod();            //Mesurer l'humidite du sol via le capteur Carbone
  int  ADJ_humMax();         //Humidity ADJ est utilisee pour ajuster la valeur maximum de l'humidite du sol
  void pumpOff();           //Eteindre la pompe
  void pumpTestOn();       //Tester le bon fonctionnement de la pompe
  void Initialization();  //Initialisation du kit d'arrosage automatique
};
#endif
 
