/*
Connection:
1.DHT11 & Free Life v1.0 board
    S      ---   Digital Pin9
   VCC     ---   VCC
   GND     ---   GND
   
2.Moisture Sensor(Humidity) & Free Life v1.0 board 
    1S      ---   Analog Pin2
   2GND     ---   GND
   3VCC     ---   VCC
*/

#include "AutoWatering.h"
#include <DHT.h>

#define MaxTemprature 100  //La valeur maximale des temperatures
#define SensorTest 1
#define CarbonTest 0 // Seulement si vous disposez du capteur de carbone


AutoWatering flower;

void setup()
{
  flower.Initialization();//Initialisation du kit d'arrosage
  Serial.begin(115200);//La vitesse de transmission est initialisee a la valeur de 115200bps
}
void loop()
{
  //Mise en route de la pompe en fonction de la temperature ambiante et de l'humidite
  pumpOn(SensorTest,CarbonTest,MaxTemprature);
  //Demarrage de la pompe pour verifier son bon fonctionnement
  //flower.pumpTestOn();  
  delay(500);
  flower.pumpOff();
  delay(10000);
  Serial.println();
}

//Mise en route de la pompe en fonction de la temperature ambiante et de l'humidite
void pumpOn(int MoiSensor, int Carbon, int Temperature_max)  
{
   int humidity;
   int humidity_max;
   float dht_t;
   
   //Pour choisir d'utiliser le capteur d'humidite ou de carbone
   //Pour tester le capteur d'humidite
   if(MoiSensor==1&&Carbon==0) 
   {
    humidity = flower.MoistureSensor();
   }else if(MoiSensor==0&&Carbon==1)
   {
    humidity = flower.CarbonRod();
   }else{
    humidity = 0;
   }
   Serial.print("Le taux d'humidite dans le sol est : ");
   Serial.print(humidity);
   Serial.println("%");
   
   humidity_max = flower.ADJ_humMax(); 
   
   Serial.print("La temperature maximale en degre Celsius pour le declenchement de la pompe est : ");
   Serial.print(MaxTemprature);
   Serial.println("C");
   
   dht_t = flower.getTemperature();
   Serial.print("La temperature en degre Celsius est de : ");
   Serial.print(dht_t);
   Serial.println("C");
   
   digitalWrite(6,LOW);
   digitalWrite(5,LOW);
   digitalWrite(7,LOW);
   digitalWrite(4,LOW);
   
   if(humidity<=humidity_max&&dht_t<=Temperature_max)
    {
      digitalWrite(6,HIGH);
      digitalWrite(5,HIGH);
       Serial.println("La pompe est allumee!");
     }
   else
    {
      digitalWrite(6,LOW);
      digitalWrite(5,LOW);
    }
}
